<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.metabolic.efm.output.mat;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.File;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.IOException;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.OutputStream;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.util.LinkedHashMap;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.util.List;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.util.Map;<a name="line.41"></a>
<FONT color="green">042</FONT>    <a name="line.42"></a>
<FONT color="green">043</FONT>    import ch.javasoft.jsmat.MatOutputStreamWriter;<a name="line.43"></a>
<FONT color="green">044</FONT>    import ch.javasoft.jsmat.MatWriter;<a name="line.44"></a>
<FONT color="green">045</FONT>    import ch.javasoft.jsmat.ReservedComplexWriter;<a name="line.45"></a>
<FONT color="green">046</FONT>    import ch.javasoft.jsmat.ReservedMatrixWriter;<a name="line.46"></a>
<FONT color="green">047</FONT>    import ch.javasoft.jsmat.variable.MatCell;<a name="line.47"></a>
<FONT color="green">048</FONT>    import ch.javasoft.jsmat.variable.MatCharMatrix;<a name="line.48"></a>
<FONT color="green">049</FONT>    import ch.javasoft.jsmat.variable.MatDoubleMatrix;<a name="line.49"></a>
<FONT color="green">050</FONT>    import ch.javasoft.jsmat.variable.MatMatrix;<a name="line.50"></a>
<FONT color="green">051</FONT>    import ch.javasoft.jsmat.variable.MatReservedMatrix;<a name="line.51"></a>
<FONT color="green">052</FONT>    import ch.javasoft.jsmat.variable.MatReservedStructure;<a name="line.52"></a>
<FONT color="green">053</FONT>    import ch.javasoft.jsmat.variable.MatVariable;<a name="line.53"></a>
<FONT color="green">054</FONT>    <a name="line.54"></a>
<FONT color="green">055</FONT>    public class MatFileWriter  {<a name="line.55"></a>
<FONT color="green">056</FONT>            <a name="line.56"></a>
<FONT color="green">057</FONT>            private final MatWriter mMatOut;<a name="line.57"></a>
<FONT color="green">058</FONT>            private final String    mStructName;<a name="line.58"></a>
<FONT color="green">059</FONT>            <a name="line.59"></a>
<FONT color="green">060</FONT>            private ReservedComplexWriter   mStructWriter;<a name="line.60"></a>
<FONT color="green">061</FONT>            <a name="line.61"></a>
<FONT color="green">062</FONT>            private final Map&lt;String, MatVariable&gt;    mFields = new LinkedHashMap&lt;String, MatVariable&gt;();<a name="line.62"></a>
<FONT color="green">063</FONT>            <a name="line.63"></a>
<FONT color="green">064</FONT>            public MatFileWriter(File file, String structName) throws IOException {<a name="line.64"></a>
<FONT color="green">065</FONT>                    mMatOut         = new ch.javasoft.jsmat.MatFileWriter(file);<a name="line.65"></a>
<FONT color="green">066</FONT>                    mStructName     = structName;<a name="line.66"></a>
<FONT color="green">067</FONT>            }       <a name="line.67"></a>
<FONT color="green">068</FONT>            <a name="line.68"></a>
<FONT color="green">069</FONT>            public MatFileWriter(OutputStream out, String structName) throws IOException {<a name="line.69"></a>
<FONT color="green">070</FONT>                    mMatOut         = new MatOutputStreamWriter(out);<a name="line.70"></a>
<FONT color="green">071</FONT>                    mStructName     = structName;<a name="line.71"></a>
<FONT color="green">072</FONT>            }<a name="line.72"></a>
<FONT color="green">073</FONT>    <a name="line.73"></a>
<FONT color="green">074</FONT>            public void write(String name, String value) {<a name="line.74"></a>
<FONT color="green">075</FONT>                    mFields.put(name, new MatCharMatrix(value));<a name="line.75"></a>
<FONT color="green">076</FONT>            }<a name="line.76"></a>
<FONT color="green">077</FONT>            public void write(String name, String[] values) {<a name="line.77"></a>
<FONT color="green">078</FONT>                    mFields.put(name, new MatCell(values));<a name="line.78"></a>
<FONT color="green">079</FONT>            }<a name="line.79"></a>
<FONT color="green">080</FONT>    <a name="line.80"></a>
<FONT color="green">081</FONT>            public void write(String name, double[] values) {<a name="line.81"></a>
<FONT color="green">082</FONT>                    mFields.put(name, new MatDoubleMatrix(values, true /*row vector*/));<a name="line.82"></a>
<FONT color="green">083</FONT>            }<a name="line.83"></a>
<FONT color="green">084</FONT>    <a name="line.84"></a>
<FONT color="green">085</FONT>            public void write(String name, double[][] values) {<a name="line.85"></a>
<FONT color="green">086</FONT>                    mFields.put(name, new MatDoubleMatrix(values));<a name="line.86"></a>
<FONT color="green">087</FONT>            }<a name="line.87"></a>
<FONT color="green">088</FONT>            public void write(String name, List&lt;double[]&gt; values, boolean rowsInList) {<a name="line.88"></a>
<FONT color="green">089</FONT>                    MatDoubleMatrix mx = rowsInList ? <a name="line.89"></a>
<FONT color="green">090</FONT>                            MatDoubleMatrix.createMatrixFromRows(values) :<a name="line.90"></a>
<FONT color="green">091</FONT>                            MatDoubleMatrix.createMatrixFromColumns(values);<a name="line.91"></a>
<FONT color="green">092</FONT>                    mFields.put(name, mx);<a name="line.92"></a>
<FONT color="green">093</FONT>            }<a name="line.93"></a>
<FONT color="green">094</FONT>            public void write(String name, int value) {<a name="line.94"></a>
<FONT color="green">095</FONT>                    write(name, new int[] {value});<a name="line.95"></a>
<FONT color="green">096</FONT>            }<a name="line.96"></a>
<FONT color="green">097</FONT>            public void write(String name, int[] values) {<a name="line.97"></a>
<FONT color="green">098</FONT>                    MatMatrix&lt;int[]&gt; mxInt = MatMatrix.createIntMatrix(values, 1, values.length);<a name="line.98"></a>
<FONT color="green">099</FONT>                    mFields.put(name, mxInt);<a name="line.99"></a>
<FONT color="green">100</FONT>            }<a name="line.100"></a>
<FONT color="green">101</FONT>            <a name="line.101"></a>
<FONT color="green">102</FONT>            public &lt;A&gt; ReservedMatrixWriter&lt;A&gt; createReservedWriter(String fieldName, MatReservedMatrix&lt;A&gt; mx) throws IOException {<a name="line.102"></a>
<FONT color="green">103</FONT>                    mFields.put(fieldName, mx);<a name="line.103"></a>
<FONT color="green">104</FONT>                    MatReservedStructure struc = new MatReservedStructure(mFields);<a name="line.104"></a>
<FONT color="green">105</FONT>                    mStructWriter = mMatOut.createReservedWriter(mStructName, struc);               <a name="line.105"></a>
<FONT color="green">106</FONT>                    return struc.createReservedWriter(mStructWriter, mx);<a name="line.106"></a>
<FONT color="green">107</FONT>            }<a name="line.107"></a>
<FONT color="green">108</FONT>    <a name="line.108"></a>
<FONT color="green">109</FONT>            /**<a name="line.109"></a>
<FONT color="green">110</FONT>             * Write, flush and close output<a name="line.110"></a>
<FONT color="green">111</FONT>         * @throws IOException      if an i/o exception occurs, for instance cause by <a name="line.111"></a>
<FONT color="green">112</FONT>         *                                          file access<a name="line.112"></a>
<FONT color="green">113</FONT>             */<a name="line.113"></a>
<FONT color="green">114</FONT>            public void close() throws IOException {<a name="line.114"></a>
<FONT color="green">115</FONT>                    mStructWriter.close();<a name="line.115"></a>
<FONT color="green">116</FONT>                    mFields.clear();<a name="line.116"></a>
<FONT color="green">117</FONT>                    mMatOut.close();<a name="line.117"></a>
<FONT color="green">118</FONT>            }<a name="line.118"></a>
<FONT color="green">119</FONT>    <a name="line.119"></a>
<FONT color="green">120</FONT>    }<a name="line.120"></a>




























































</PRE>
</BODY>
</HTML>
